> ## Documentation Index
> Fetch the complete documentation index at: https://docs.compasslabs.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Initiate USDC bridging

> Bridge USDC to any chain for any Product account using Circle's CCTP Protocol.

**Transfer modes:**
- `standard` (default): ~15-19 minute transfers, **free** (no fee)
- `fast`: ~30 second transfers, requires a small fee (typically ~0.01%)

The fee for fast mode is automatically calculated based on Circle's current rates.

**Flow:**
1. Call this endpoint with `gas_sponsorship=false` to get an unsigned transaction,
   or `gas_sponsorship=true` to get EIP-712 typed data for gas-sponsored execution
2. Owner signs the transaction or typed data
3. Broadcast the transaction on the source chain (or submit to `/gas_sponsorship/prepare`)
4. Wait for Circle's attestation service to attest the burn
5. Call the mint endpoint to receive USDC on the destination chain 

**Supported chains:**
- Ethereum (domain 0)
- Arbitrum (domain 3)
- Base (domain 6)

**Note:** The USDC must already be deposited in the Product Account. If approval is needed
for the TokenMessengerV2 contract, it will be included in the transaction automatically.



## OpenAPI

````yaml /v2/combined_spec.json post /v2/cctp/burn
openapi: 3.1.0
info:
  title: Compass API
  description: Compass Labs DeFi API
  version: 0.0.1
servers:
  - url: https://api.compasslabs.ai
    description: Production server
security:
  - ApiKeyAuth: []
paths:
  /v2/cctp/burn:
    post:
      tags:
        - Bridge
      summary: Initiate USDC bridging
      description: >-
        Bridge USDC to any chain for any Product account using Circle's CCTP
        Protocol.


        **Transfer modes:**

        - `standard` (default): ~15-19 minute transfers, **free** (no fee)

        - `fast`: ~30 second transfers, requires a small fee (typically ~0.01%)


        The fee for fast mode is automatically calculated based on Circle's
        current rates.


        **Flow:**

        1. Call this endpoint with `gas_sponsorship=false` to get an unsigned
        transaction,
           or `gas_sponsorship=true` to get EIP-712 typed data for gas-sponsored execution
        2. Owner signs the transaction or typed data

        3. Broadcast the transaction on the source chain (or submit to
        `/gas_sponsorship/prepare`)

        4. Wait for Circle's attestation service to attest the burn

        5. Call the mint endpoint to receive USDC on the destination chain 


        **Supported chains:**

        - Ethereum (domain 0)

        - Arbitrum (domain 3)

        - Base (domain 6)


        **Note:** The USDC must already be deposited in the Product Account. If
        approval is needed

        for the TokenMessengerV2 contract, it will be included in the
        transaction automatically.
      operationId: v2_cctp_burn
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/DepositForBurnRequest'
        required: true
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/DepositForBurnResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      x-codeSamples:
        - lang: python
          label: Python (SDK)
          source: |-
            from compass_api_sdk import CompassAPI, models


            with CompassAPI(
                api_key_auth="<YOUR_API_KEY_HERE>",
            ) as compass_api:

                res = compass_api.bridge.cctp_burn(owner="0x06A9aF046187895AcFc7258450B15397CAc67400", chain=models.DepositForBurnRequestChain.ARBITRUM, amount="3", destination_chain=models.DestinationChain.BASE, gas_sponsorship=True, transfer_mode=models.DepositForBurnRequestTransferMode.STANDARD)

                # Handle response
                print(res)
        - lang: typescript
          label: Typescript (SDK)
          source: |-
            import { CompassApiSDK } from "@compass-labs/api-sdk";

            const compassApiSDK = new CompassApiSDK({
              apiKeyAuth: "<YOUR_API_KEY_HERE>",
            });

            async function run() {
              const result = await compassApiSDK.bridge.cctpBurn({
                owner: "0x06A9aF046187895AcFc7258450B15397CAc67400",
                chain: "arbitrum",
                amount: "3",
                destinationChain: "base",
                gasSponsorship: true,
                transferMode: "standard",
              });

              console.log(result);
            }

            run();
components:
  schemas:
    DepositForBurnRequest:
      properties:
        owner:
          type: string
          title: Owner
          description: >-
            The primary wallet address that owns and controls the Product
            Account.
          examples:
            - '0x29F20a192328eF1aD35e1564aBFf4Be9C5ce5f7B'
          default: '0x06A9aF046187895AcFc7258450B15397CAc67400'
        chain:
          type: string
          enum:
            - ethereum
            - arbitrum
            - base
          title: Chain
          description: The source chain where USDC will be burned.
          examples:
            - base
            - ethereum
            - arbitrum
          default: arbitrum
        amount:
          anyOf:
            - type: number
              exclusiveMinimum: 0
            - type: string
              pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
          title: Amount
          description: >-
            The amount of USDC to bridge (in token units, e.g., 100.5 for 100.5
            USDC).
          examples:
            - 100
            - 1000.5
          default: '3'
        destination_chain:
          type: string
          enum:
            - ethereum
            - arbitrum
            - base
          title: Destination Chain
          description: The destination chain where USDC will be minted.
          examples:
            - ethereum
            - arbitrum
            - base
          default: base
        gas_sponsorship:
          type: boolean
          title: Gas Sponsorship
          description: >-
            Optionally request gas sponsorship. If set to `true`, EIP-712 typed
            data will be returned that must be signed by the `owner` and
            submitted to the 'Prepare gas-sponsored transaction' endpoint
            (`/gas_sponsorship/prepare`).
          default: false
          examples:
            - true
        transfer_mode:
          type: string
          enum:
            - fast
            - standard
          title: Transfer Mode
          description: >-
            Transfer speed mode. 'fast': ~30 second transfers using confirmed
            finality (requires a small fee taken from transfer amount).
            'standard': ~15-19 minute transfers using full finality (free, no
            fee). Default is 'standard'.
          default: standard
          examples:
            - standard
            - fast
      type: object
      required:
        - owner
        - chain
        - amount
        - destination_chain
      title: DepositForBurnRequest
      default:
        owner: '0x06A9aF046187895AcFc7258450B15397CAc67400'
        chain: arbitrum
        amount: '3'
        destination_chain: base
        gas_sponsorship: true
        transfer_mode: standard
    DepositForBurnResponse:
      properties:
        bridge_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Bridge Id
          description: >-
            Unique bridge identifier for tracking this cross-chain transfer. Use
            this ID when calling /mint/prepare to complete the transfer. Only
            present when Redis is configured on the server.
          examples:
            - br_a1b2c3d4e5f6
        transaction:
          anyOf:
            - $ref: '#/components/schemas/UnsignedTransaction'
            - type: 'null'
          description: >-
            Unsigned transaction for direct execution. Present when
            gas_sponsorship=false.
        eip_712:
          anyOf:
            - $ref: '#/components/schemas/BatchedSafeOperationsResponse-Output'
            - type: 'null'
          description: >-
            EIP-712 typed data for gas-sponsored execution. Present when
            gas_sponsorship=true.
        transfer_mode:
          type: string
          enum:
            - fast
            - standard
          title: Transfer Mode
          description: >-
            The transfer speed mode used. 'fast' uses confirmed finality (~30s),
            'standard' uses full finality (~15-19 min).
          examples:
            - standard
            - fast
        fee:
          anyOf:
            - type: string
              pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
            - type: 'null'
          title: Fee
          description: >-
            Fee amount in USDC charged for this transfer. Only present for fast
            mode. Standard mode transfers are free (fee is None or 0).
          examples:
            - 0.01
            - null
        estimated_time_seconds:
          type: integer
          title: Estimated Time Seconds
          description: Estimated time to complete the bridge in seconds.
          examples:
            - 30
            - 900
      type: object
      required:
        - transfer_mode
        - estimated_time_seconds
      title: DepositForBurnResponse
      description: >-
        Response model for CCTP depositForBurn transaction from a smart account.


        Contains either an unsigned transaction for direct submission or EIP-712
        typed data

        for gas-sponsored transactions. Also includes a bridge_id for tracking
        the cross-

        chain transfer.
      example:
        bridge_id: br_a1b2c3d4e5f6
        estimated_time_seconds: 900
        transaction:
          chainId: '0x2105'
          data: >-
            0x8d80ff0a0000000000000000000000000000000000000000000000000000000000000020
          from: '0x4A83b4413CF41C3244027e1590E35a0F48403F0c'
          gas: '0x7a120'
          maxFeePerGas: '0x59682f00'
          maxPriorityFeePerGas: '0x3b9aca00'
          nonce: '0x5'
          to: '0x6B90E8B4E3E971E74C1A47a3a20976377E2dB4b1'
          value: '0x0'
        transfer_mode: standard
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    UnsignedTransaction:
      properties:
        chainId:
          type: string
          title: Chainid
          description: The chain id of the transaction
        data:
          type: string
          title: Data
          description: The data of the transaction
        from:
          type: string
          title: From
          description: The sender of the transaction
        gas:
          anyOf:
            - type: string
            - type: 'null'
          title: Gas
          description: The gas of the transaction
        to:
          type: string
          title: To
          description: The recipient of the transaction
        value:
          type: string
          title: Value
          description: The value of the transaction
        nonce:
          type: string
          title: Nonce
          description: The nonce of the address
        maxFeePerGas:
          type: string
          title: Maxfeepergas
          description: The max fee per gas of the transaction
        maxPriorityFeePerGas:
          type: string
          title: Maxpriorityfeepergas
          description: The max priority fee per gas of the transaction
      type: object
      required:
        - chainId
        - data
        - from
        - gas
        - to
        - value
        - nonce
        - maxFeePerGas
        - maxPriorityFeePerGas
      title: UnsignedTransaction
      example:
        chainId: '0x2105'
        data: >-
          0x1688f0b900000000000000000000000029fcb43b46531bca003ddc8fcb67ffe91900c762000000000000000000000000000000000000000000000000000000000000006000000000000000000000000000000000000000000000000000000000675f4a3d
        from: '0x4A83b4413CF41C3244027e1590E35a0F48403F0c'
        gas: '0x7a120'
        maxFeePerGas: '0x59682f00'
        maxPriorityFeePerGas: '0x3b9aca00'
        nonce: '0x5'
        to: '0x4e1DCf7AD4e460CfD30791CCC4F9c8a4f820ec67'
        value: '0x0'
    BatchedSafeOperationsResponse-Output:
      properties:
        domain:
          $ref: >-
            #/components/schemas/compass__api_backend__v2__models__safe__transact__response__batched_safe_operations__EIP712Domain
          description: EIP-712 domain separator
        types:
          $ref: >-
            #/components/schemas/compass__api_backend__v2__models__safe__transact__response__batched_safe_operations__EIP712Types
          description: EIP-712 type definitions
        primaryType:
          type: string
          const: SafeTx
          title: Primarytype
          description: Primary type for the structured data
        message:
          $ref: '#/components/schemas/SafeTxMessage'
          description: Safe transaction message data
      type: object
      required:
        - domain
        - types
        - primaryType
        - message
      title: BatchedSafeOperationsResponse
      description: Response containing EIP-712 typed data for Safe transaction signing.
      example:
        domain:
          chainId: 8453
          verifyingContract: '0x6B90E8B4E3E971E74C1A47a3a20976377E2dB4b1'
        message:
          baseGas: '0'
          data: >-
            0x8d80ff0a0000000000000000000000000000000000000000000000000000000000000020
          gasPrice: '0'
          gasToken: '0x0000000000000000000000000000000000000000'
          nonce: '7'
          operation: 1
          refundReceiver: '0x0000000000000000000000000000000000000000'
          safeTxGas: '0'
          to: '0x93C23AAE4793C14D6DF35D2A2A2234204e1559dA'
          value: '0'
        primaryType: SafeTx
        types:
          EIP712Domain:
            - name: chainId
              type: uint256
            - name: verifyingContract
              type: address
          SafeTx:
            - name: to
              type: address
            - name: value
              type: uint256
            - name: data
              type: bytes
            - name: operation
              type: uint8
            - name: safeTxGas
              type: uint256
            - name: baseGas
              type: uint256
            - name: gasPrice
              type: uint256
            - name: gasToken
              type: address
            - name: refundReceiver
              type: address
            - name: nonce
              type: uint256
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    compass__api_backend__v2__models__safe__transact__response__batched_safe_operations__EIP712Domain:
      properties:
        chainId:
          type: integer
          title: Chainid
          description: Chain ID
        verifyingContract:
          type: string
          title: Verifyingcontract
          description: Address of the Product Account
      type: object
      required:
        - chainId
        - verifyingContract
      title: EIP712Domain
      description: The EIP-712 domain separator.
    compass__api_backend__v2__models__safe__transact__response__batched_safe_operations__EIP712Types:
      properties:
        EIP712Domain:
          items:
            $ref: '#/components/schemas/EIP712DomainField'
          type: array
          title: Eip712Domain
          description: EIP712Domain type definition
        SafeTx:
          items:
            $ref: '#/components/schemas/SafeTxField'
          type: array
          title: Safetx
          description: SafeTx type definition
      type: object
      required:
        - EIP712Domain
        - SafeTx
      title: EIP712Types
      description: The type definitions for EIP-712 structured data.
    SafeTxMessage:
      properties:
        to:
          type: string
          title: To
          description: Destination address
        value:
          type: string
          title: Value
          description: Value in wei as a string
        data:
          type: string
          title: Data
          description: Transaction data as hex string
        operation:
          $ref: '#/components/schemas/OperationType'
          description: Operation type (0=Call, 1=DelegateCall)
        safeTxGas:
          type: string
          title: Safetxgas
          description: Gas for the transaction
        baseGas:
          type: string
          title: Basegas
          description: Base gas costs
        gasPrice:
          type: string
          title: Gasprice
          description: Gas price
        gasToken:
          type: string
          title: Gastoken
          description: Token address for gas payment
        refundReceiver:
          type: string
          title: Refundreceiver
          description: Address to receive gas refund
        nonce:
          type: string
          title: Nonce
          description: Transaction nonce
      type: object
      required:
        - to
        - value
        - data
        - operation
        - safeTxGas
        - baseGas
        - gasPrice
        - gasToken
        - refundReceiver
        - nonce
      title: SafeTxMessage
      description: The message data for the transaction.
    EIP712DomainField:
      properties:
        name:
          type: string
          title: Name
        type:
          type: string
          title: Type
      type: object
      required:
        - name
        - type
      title: EIP712DomainField
      description: A field in the EIP712Domain type definition.
    SafeTxField:
      properties:
        name:
          type: string
          title: Name
        type:
          type: string
          title: Type
      type: object
      required:
        - name
        - type
      title: SafeTxField
      description: A field in the SafeTx type definition.
    OperationType:
      type: integer
      enum:
        - 0
        - 1
      title: OperationType
      description: Safe operation types.
  securitySchemes:
    ApiKeyAuth:
      type: apiKey
      in: header
      name: x-api-key
      description: >-
        Your Compass API Key. Get your key
        [here](https://www.compasslabs.ai/dashboard).

````